%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% This script is used to obtain the results in the paper
%%%% "Tree-structured compressed sensing MRI"
%%%%% Jan. 21, 2013, Created by Chen Chen and Junzhou Huang in University
%%%%% of Texas at Arlington
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

close all; clear all;

addpath(strcat(pwd,'/utils'));
load brain;
temp =im;
minv = min(min(abs(temp)));
maxv = max(max(abs(temp)));
F =(temp-minv)/(maxv-minv);
% F = imresize(F,[256,256]);
% load brain_8ch;
% load TSE_TE94ms;
% load TSE_TE27ms;
% temp = (img(:,:,10));
% minv = min(min(abs(temp)));
% maxv = max(max(abs(temp)));
% F =(temp-minv)/(maxv-minv);
% load SL_complex;
% % temp = (img(:,:,20));
% temp = img(:,:,1) +1i*img(:,:,2);
% minv = min(min(abs(temp)));
% maxv = max(max(abs(temp)));
% F =(temp-minv)/(maxv-minv);

c=0;
 
alpha = 0.0005; 
beta = 0.005; 

% for k = 1:8   % from channel 1 to 8
%     temp(:,:,k) = fftshift(ifft2(fftshift(raw_data(:,:,k))));
% end
%     F = sqrt(sum((abs(temp).^2),3));
%     F = (F - min(abs(F(:))))/( max(abs(F(:)))- min(abs(F(:))));
% figure;imshow(abs(F),[]);
% for k = 1:8   % from channel 1 to 8
% fprintf('Channel %d-------------------------------------------------\n',k); 

% temp(:,:,k) = fftshift(ifft2(fftshift(DATA(:,:,k))));
% % temp = imresize(temp,[128,128]);
% % F = imresize(temp(:,:,k),[128,128]);
% F = temp(:,:,k);
% F = (F - min(abs(F(:))))/( max(abs(F(:)))- min(abs(F(:))));
% F = imresize(F,[128,128]);
% % F = F*255;
% temp0(:,:,k) = F;
% ff(:,k) = F(:); 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% L1 Recon Parameters 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[m,n] = size(F);
N = size(F); 	% image Size
DN = size(F); 	% data Size
Itnlim = 20;   % Number of iterations

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Sampling Mask
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% d = 4.4;
% [OMEGA] = RandMask_rect(double(m/d),double(n/d),m,n);
% [mask] = RandMask_InverseTransfer(OMEGA,m,n); 
d = 100;
OMEGA=fftshift(MRImask(m,d));  % set 50--0.21
OMEGA = find(OMEGA==1);
  k = length(OMEGA);
  k/(m*n)
%   
[mask] = RandMask_InverseTransfer(OMEGA,m,n); 
% figure;imshow(mask,[]);
% d = 2.0;
% pdf = genPDF([1,m], 6, 1/d, 2, 0.1, 0);
% OMEGA = fftshift(repmat(genSampling_symmetric(pdf,10,1),[m,1]));
% OMEGA = find(OMEGA==1);
% [mask] = RandMask_InverseTransfer(OMEGA,m,n); 
%  figure;imshow(mask,[]);

sigma = 0.00;
%generate Fourier sampling operator
FT = p2DFT(mask, N, 1, 2);
data = FT*F;
data = data.*mask+sigma*randn(m,n)+1i*sigma*randn(m,n);

im_dc = FT'*(data);
im_dc = im_dc/max(abs(im_dc(:)));

%generate transform operator
XFM = Wavelet('Daubechies',4,6);	% Wavelet

%initialize Parameters for reconstruction
param = init;
param.FT = FT;
param.XFM = XFM;
param.TV = TVOP;
param.data = data.*mask;
param.TVWeight =alpha*2;     % TV penalty 
param.xfmWeight = beta*2;  % L1 wavelet penaltys
param.Itnlim = Itnlim;
param.f = F;

res = XFM*im_dc;
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CG
% do iterations
fprintf('calling the function CG.....\n');
[res,snrtrace,timetrace] = fnlCg(res,param);
im_res = XFM'*res;

im1 = im_res;
SNR1 = snrtrace;
TIME1 = timetrace;

fprintf(1,'Iter_time = %.2fsec, Iteration Num = %d, snr = %f \n',timetrace(end), param.Itnlim, snrtrace(end));

% figure;imshow(abs(im1),[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FCSA
% do iterations
input.f=abs(F);
input.n1=N(1);
input.n2=N(2);
input.alpha=alpha;input.beta=beta;
input.Phi=XFM;
input.maxitr=5000;input.maxiitr= 5000;
input.stopCriterion=2; 
input.tolA=1e-8; input.no=Itnlim; 
input.L=1;input.num=1; 
input.l=-inf; input.u=inf;
input.b=data;input.A=FT;

fprintf('calling the function FCSA.....\n');
out = TVS_FCSAy2D(input);
out2=out;im2 = out.y; im2=reshape(im2, [m, n]);
fprintf(1,'Iter_time = %.2fsec, Iteration Num = %d, snr = %f \n',out.xtime(end), input.no, out.snr(end));

% snr3(k) = snr(abs(im3),abs(F));
% im2 = im3;
SNR2 = out.snr;
TIME2 = out.xtime;

% figure;imshow(abs(im2),[]);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FISTA_Tree
DecLevel=6;
[IdxParent, IdxChildren, Ms] = WaveTreeStructure2D(m,DecLevel);
[G,Gmat,GmatX,groups]=GroupMatrics(IdxParent);
input.G=G;input.Gt=G';input.GtG=G'*G;
input.groups=groups;input.Gmat=Gmat;
input.alpha=alpha;input.beta=beta/20;lamda = 0.025;
input.lamda=lamda;
input.no=Itnlim; 
fprintf('calling the function WaTMRI.....\n');
out = WaTMRI_S2D(input);
out3=out;im3 = out.y; im3=reshape(im3, [m, n]);
fprintf(1,'Iter_time = %.2fsec, Iteration Num = %d, snr = %f \n',out.xtime(end), input.no, out.snr(end));
% snr4(k) = snr(abs(im4),abs(F));
SNR3 = out.snr;
% im3 = im4;
TIME3 = out.xtime;

% figure;imshow(abs(im3),[]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FCSA_JOint
F2(:,:,1)=real(F);
% temp = imag(img(:,:,6));
F2(:,:,2)=imag(F);
F2 = F2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% FCSA_MT
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('calling the function TVS_FCSA_MT.....\n');

T = 2;
% wav = daubcqf(2);W = @(x) midwt(x,wav);WT = @(x) mdwt(x,wav);
% Phi= A_operator(@(x) WT(x), @(x) W(x));    % notice Phi=WT
wav = daubcqf(2);%W = @(x) midwt(x,wav,DecLevel);WT = @(x) mdwt(x,wav,DecLevel);
WT = @(x) reshape(mdwt(reshape(x,m,n),wav,DecLevel),m*n,1);
W = @(x) reshape(midwt(reshape(x,m,n),wav,DecLevel),m*n,1);
Phi= A_operator(@(x) WT(x), @(x) W(x));    % notice Phi=WT
pn = m*n;
start=0;stop=0;
for t=1:T,
          
     f2=F2(:,:, t); f(:,t)=f2(:); xs(:,t)=WT(f(:,t));
%      [OMEGA{t}] = RandMask_rect(double(m/d),double(n/d),m,n);
     k = length(OMEGA);
%      [mask{t}] = RandMask_InverseTransfer(OMEGA{t},m,n); 
     start=stop+1; stop=start+2*k;
     sz(t,:)=[start, stop, pn];
     
     R{t} = @(x) A_fhp_rect(x, OMEGA, m, n);
     RT{t} = @(x) At_fhp_rect(x, OMEGA, m, n);
     sigma = 0.01; noise = sigma*randn(2*k+1,1); 
     RR{t} = A_operator(@(x) R{t}(x), @(x) RT{t}(x));
     b{t} = RR{t}*f(:,t) + noise;
end
input1=input; input1.Phi=Phi;input1.f= F2(:);
input1.alpha=alpha;input1.beta=beta;
out = TVS_FCSA_MT(b, RR, f, input1);
out4=out;img = out.y; 
for t=1:T, 
    x4(:,t)=Phi*img(:,t); 
end
im4=reshape(img, [m, n, T]);

im4 = sqrt(sum(im4.^2,3));
SNR4 = snr(F,im4)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% FISTA_Forest
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('calling the function FISTA_Forest.....\n');
% input1=input; 
input1.alpha=alpha;input1.beta=beta/30;input1.lamda=0.05;
out = FISTA_Forest(b, RR, f, input1);
out5=out;img = out.y; 
for t=1:T, 
    x5(:,t)=Phi*img(:,t); 
end
im5=reshape(img, [m, n, T]);
im5 = sqrt(sum(im5.^2,3));
SNR5 = snr(F,im5)


% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%% NESTA tree
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('calling the function NESTA_Tree.....\n');
muf = 3e-5;
opts = [];
opts.Verbose = 0;opts.TypeMin='l21';
delta = 1e-8;opts.MaxIntIter=1;
opts.maxiter=50;
% muf = mu/20;

opts.l=-inf;opts.up=inf;

 RF = @(x) [ RR{1}*(x(pn*(1-1)+1:pn)); RR{2}*(x(pn*(2-1)+(1:pn)))];
 RFT = @(x) [ RR{1}'*(x(sz(1,1):sz(1,2))); RR{2}'*(x(sz(2,1):sz(2,2))) ];
 WW = @(x) [ Phi*(x(pn*(1-1)+1:pn)); Phi*(x(pn*(2-1)+(1:pn))) ];
 WWT = @(x) [ Phi'*(x(pn*(1-1)+1:pn)); Phi'*(x(pn*(2-1)+(1:pn)))];
 
pg = size(G,1);
groups=[groups;groups];Gmat=[Gmat Gmat];

GG=@(x) [G*x(pn*(1-1)+(1:pn));G*x(pn*(2-1)+(1:pn))];
GGT=@(x) [G'*x(pg*(1-1)+(1:pg));G'*x(pg*(2-1)+(1:pg))];
% opts.l=0;opts.up=255;

% opts.U=Phi;
% opts.Ut = Phi';

% opts.Verbose = 0;opts.TypeMin='l1';
opts.groups=groups;opts.Gmat=Gmat;
 opts.U = @(x) GG(WW(x));
 opts.Ut = @(x) WWT(GGT(x));
bb = [b{1};b{2}];
% muf = mu;


% opts = [];
% opts.l=0;opts.up=255;
% opts.U=@(x) G*(Phi*x);
% opts.Ut =@(x) Phi'*(G'*x);

opts.groups=groups;opts.Gmat=Gmat;
% delta = 1e-8;opts.MaxIntIter=1;

% opts.maxiter=100;

opts.f=F2(:);
[xk,niter,resid,outData] = NESTA(RF,RFT,bb,muf,delta,opts);
im6=reshape(xk, [m, n,2]);
im6 = sqrt(sum(im6.^2,3));
SNR6 = snr(F,im6)
% SNR6(:,iter) = outData.snr;
% Time6(:,iter) = outData.xtime;
% SNR6(end)

FSNR3 = outData.snr;
figure;plot(FSNR3);

% SNR4=out.snr'; Time4=out.xtime;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure;imshow(abs(cat(2,F,im1,im4,im5,im6)),[]);
figure;imshow(abs(cat(2,abs(im1)-abs(F),im4-abs(F),im5-abs(F),im6-abs(F))),[0 0.1]);

lw=3;
figure; hold on;box on;
plot(SNR1, 'm+-.','linewidth', lw);
plot(out4.snr, 'k:','linewidth', lw);
plot(out5.snr, 'g-.','linewidth', lw);
legend('CG','FCSA','FISTA\_Tree','NESTA','NESTA\_Tree','Location','SouthEast');

cimg(:,:,1) = F;
cimg(:,:,2) = im1;
cimg(:,:,3) = im4;
cimg(:,:,4) = im5;
cimg(:,:,5) = im6;
out = showzoomin(abs(cimg)*255);
figure;imshow(out,[]);

figure;imshow(abs(F),[]);
figure;imshow(abs(im1),[]);
figure;imshow(abs(im4),[]);
figure;imshow(abs(im5),[]);
figure;imshow(abs(im6),[]);
figure;imshow(abs(mask),[]);
% xlabel('Iterations');
% ylabel('SNR');
% % axis([0 50 9 16.5]);
% textobj = findobj('type', 'text');
% set(textobj, 'fontsize', 14);
% h_xlabel = get(gca,'XLabel');
% set(h_xlabel,'FontSize',14); 
% h_xlabel = get(gca,'YLabel');
% set(h_xlabel,'FontSize',14); 