close all; clear all; 
rand('state',0); randn('state',0);
load ImgData;
F=ImgData;
%F1 = double(imread('CoroalT1.png'));
% F=zeros(128, 128);
% F=F1(1:128, 1:128);
%F=imresize(F1, [512 512]);
% F=im256(F);  figure; imshow(F, [])
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Preparing the data and operators
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[m m] = size(F); N = m*m; 
f = F(:);
d = 2;   %%%% choose 3, 4, 
[OMEGA] = RandMask_rect(double(m/d),double(m/d),m,m);
% Number of projections
k = length(OMEGA);
[mask] = RandMask_InverseTransfer(OMEGA,m,m); 
% partial FFT tranform
R = @(x) A_fhp_rect(x, OMEGA, m, m);
RT = @(x) At_fhp_rect(x, OMEGA, m, m);

wav = daubcqf(2);W = @(x) midwt(x,wav, 4);WT = @(x) mdwt(x,wav, 4);

AO = @(x) R(W(x)); AOT = @(x) WT(RT(x)); 
A = A_operator(@(x) AO(x), @(x) AOT(x));
Phi = A_operator(@(x) WT(x), @(x) W(x));    % notice Phi=WT
RR = A_operator(@(x) R(x), @(x) RT(x));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sigma = 0.00; noise = sigma*randn(2*k+1,1); 
b = R(f) + noise;
x0=WT(f);

[IdxParent, IdxChildren, Ms] = WaveTreeStructure2D(m, 4);


% Set the numbers of groups and nonzero groups
nGroups = m*m;
% K = nGroups / 8;
groups = cell(nGroups,1);
gnum=zeros(nGroups,1);
% Generate overlapping groups
for i = 1:nGroups
    temp=IdxParent(i);
    if temp~=0
        groups{i}  = [i; IdxParent(i)];
        gnum(i)=2;
    else
        groups{i}  = [i];
        gnum(i,1)=1;
    end
end


% Determine weight for each group
% weights = ones(nGroups,1);
weights = 1./sqrt(gnum);

% Set stopping tolerance value
noise_std=0;
tol = max(0.1*noise_std, 1e-6);

%%%%%%%%%%%%%%%%%

    nG = length(groups); % # of groups
    n = N;
    % Preprocess the groups
    gcat = cat(1,groups{:});
    N = length(gcat);
    gidx = unique(gcat);
    if min(gidx)~=1 || max(gidx)~=n
        error('Please normalize the group numbering');
    end
    gmat = sparse(nG,N);
    ii = 1;
    for i = 1:nG
        gmat(i,ii:ii+length(groups{i})-1) = 1;
        ii = ii + length(groups{i});
    end
    for i = 1:nG
        groups{i} = i*ones(length(groups{i}),1);
    end
    groups = cat(1,groups{:});   
    G = sparse(N,n);
    for i = 1:N
        G(i,gcat(i)) = 1;
    end  

    opts.tol = 1e-6;
opts.nonneg = false;
opts.exact = false;
opts.maxit = 10*m;
opts.solver = 2;
opts.continuation = false;
opts.contpar = 0.9;
opts.contfactor = 1.2;
opts.weights=weights;
opts.gamma = [1.618,1.618] ;
%%%%%%%%%%%%%%%%%

%% Call Primal YALL1_Group Solver with Inexact Subproblem Solving

beta = 0.1*[1,1]/mean(abs(b)); % penalty parameters
opts.beta=beta;
[x_yp,Out_yp] = overlap_primal_solver(AO,AOT,b,groups,gmat,G,opts);

relerr = norm(x_yp-x0)/norm(x0)  % relative error
fprintf('YALL1 Primal (Exact: false, Continuation: false): \n')
% fprintf('iter %4i, time %6.2f, relerr %6.2e\n\n',...
%     Out_yp.iter,Out_yp.cputime,relerr)

im=W(x_yp);im=reshape(im, [m m]);
figure; imshow(im, [])
