%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% This script is used to obtain the results in the paper
%%%% "MR Image Reconstruction with Wavelet Tree Sparsity"
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all; clear all;
rand('state',0);rand('state',0);

F = double(imread('pics/Heart.png'));
% F = double(imread('pics/3DMR_Chest.jpg'));
% F = double(imread('pics/shoulder.jpg'));
F = double(imread('pics/MRI-Brain.jpg'));

F=imresize(F, [256 256]);[m n] = size(F); 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2D wavelet transformation and sparse signal --  
DecLevel=4;
[IdxParent, IdxChildren, Ms] = WaveTreeStructure2D(m,DecLevel);
[G,Gmat,GmatX,groups]=GroupMatrics(IdxParent);
input.G=G;input.Gt=G';input.GtG=G'*G;
input.groups=groups;input.Gmat=Gmat;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Preparing the data and operators
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
N = m*n;f = F(:);
% define the function handles that compute 
% the products by W (inverse DWT) and W' (DWT)
wav = daubcqf(2);
WT = @(x) reshape(mdwt(reshape(x,m,n),wav,DecLevel),N,1);
W = @(x) reshape(midwt(reshape(x,m,n),wav,DecLevel),N,1);
W2 = @(x) midwt(x,wav,DecLevel);WT2 = @(x) mdwt(x,wav,DecLevel); %2D
Phi = A_operator(@(x) WT(x), @(x) W(x));    % notice Phi=WT


alpha = 0.1; 
beta = 3.5e-2; 
input.lamda=beta*0.2;
xs = WT(f);input.f=f; input.xs=xs;
input.n1=m;input.n2=n;
input.alpha=alpha;input.beta=beta;
input.Phi=Phi;
input.maxitr=500;input.maxiitr= 500;
input.stopCriterion=2; 
input.tolA=1e-8; input.no=100; %%%%  Change no for different iteration numbers
input.L=1;input.num=1; 
input.l=0; input.u=255;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

d = 4;   %%%% choose 3, 4, 
% Number of projections
[OMEGA] = RandMask_rect(double(m/d),double(n/d),m,n);
k = length(OMEGA);
[mask] = RandMask_InverseTransfer(OMEGA,m,n); 
% figure;imshow(mask);
sigma = 0.01; noise = sigma*randn(2*k+1,1);

% partial FFT tranform
R = @(x) A_fhp_rect(x, OMEGA, m, n);
RT = @(x) At_fhp_rect(x, OMEGA, m, n);
RR = A_operator(@(x) R(x), @(x) RT(x));
AO = @(x) R(W(x)); AOT = @(x) WT(RT(x)); 
A = A_operator(@(x) AO(x), @(x) AOT(x));
b = R(f) + noise;input.b=b;input.A=RR;
input2=input;input2.A=A;

data = zeros(m,n);data(1,1) = b(1); KK = length(b);
data(OMEGA) = b(2:(KK+1)/2) + i*b((KK+3)/2:KK);
im_poc = real(ifft2(data))*sqrt(m*n);

sampleratio = k/(m*n);
fprintf(1,'sample ratio = %.4f\n',sampleratio);

MAXTTER=5;
time0=zeros(MAXTTER,8);snrs0=zeros(MAXTTER,8);
time1=zeros(MAXTTER,input.no);time2=zeros(MAXTTER,input.no);
time3=zeros(MAXTTER,input.no);time4=zeros(MAXTTER,input.no);
snrs1=zeros(MAXTTER,input.no);snrs2=zeros(MAXTTER,input.no);
snrs3=zeros(MAXTTER,input.no);snrs4=zeros(MAXTTER,input.no);
for iter=1:MAXTTER
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% noL1_WaTMRI
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('calling the function noL1_WaTMRI.....\n');
out =nonL1_WaTMRI(input);  % matlab wavelet
out1=out;im1 = out.y; im1=reshape(im1, [m, n]);
fprintf(1,'Iter_time = %.2fsec, Iteration Num = %d, snr = %f \n',out.xtime(end), input.no, out.snr(end));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% noTV_WaTMRI
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('calling the function noTV_WaTMRI.....\n');
out = nonTV_WaTMRI(input);  % matlab wavelet
out2=out;im2 = out.y; im2=reshape(im2, [m, n]);
fprintf(1,'Iter_time = %.2fsec, Iteration Num = %d, snr = %f \n',out.xtime(end), input.no, out.snr(end));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% noboth_WaTMRI
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('calling the function noboth_WaTMRI.....\n');
out = nonboth_WaTMRI(input);  % matlab wavelet
out3=out;im3 = out.y; im3=reshape(im3, [m, n]);
fprintf(1,'Iter_time = %.2fsec, Iteration Num = %d, snr = %f \n',out.xtime(end), input.no, out.snr(end));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% WaTMRI
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('calling the function WaTMRI.....\n');
out = WaTMRI(input);  % matlab wavelet
out4=out;im4 = out.y; im4=reshape(im4, [m, n]);
fprintf(1,'Iter_time = %.2fsec, Iteration Num = %d, snr = %f \n',out.xtime(end), input.no, out.snr(end));


time1(iter,:)=out1.xtime;time2(iter,:)=out2.xtime;
time3(iter,:)=out3.xtime;time4(iter,:)=out4.xtime;
snrs1(iter,:)=out1.snr;snrs2(iter,:)=out2.snr;
snrs3(iter,:)=out3.snr;snrs4(iter,:)=out4.snr;
end

time1_M=mean(time1,1);time2_M=mean(time2,1);time3_M=mean(time3,1);time4_M=mean(time4,1);
snrs1_M=mean(snrs1,1);snrs2_M=mean(snrs2,1);snrs3_M=mean(snrs3,1);snrs4_M=mean(snrs4,1);
 
lw=3;
figure; hold on;box on;
plot(snrs1_M, 'k:','linewidth', lw);
plot(snrs2_M, 'g-.','linewidth', lw);
plot(snrs3_M, 'r--','linewidth', lw);
plot(snrs4_M, 'b-','linewidth', lw);
legend('no-L1','no-TV','no-both','WaTMRI','Location','SouthEast');
xlabel('Iterations');
ylabel('SNR');
% 
textobj = findobj('type', 'text');
set(textobj, 'fontsize', 14);
h_xlabel = get(gca,'XLabel');
set(h_xlabel,'FontSize',14); 
h_xlabel = get(gca,'YLabel');
set(h_xlabel,'FontSize',14); 

 figure; hold on;box on;
%  plot(time0_M, snrs0_M, 'm+-.','linewidth', lw);
 plot(time1_M, snrs1_M, 'k:','linewidth', lw);
 plot(time2_M, snrs2_M, 'g-.','linewidth', lw);
 plot(time3_M, snrs3_M, 'r--','linewidth', lw);
 plot(time4_M, snrs4_M, 'b-','linewidth', lw); 
% axis([0 2 3.5 20]);
legend('no-L1','no-TV','no-both','WaTMRI','Location','SouthEast');
 xlabel('CPU Time(sec)');
 ylabel('SNR');

 textobj = findobj('type', 'text');
set(textobj, 'fontsize', 14);
h_xlabel = get(gca,'XLabel');
set(h_xlabel,'FontSize',14); 
h_xlabel = get(gca,'YLabel');
set(h_xlabel,'FontSize',14); 


 figure; hold on;
 subplot(2,3,1); imshow(F, []); title('Original');

 subplot(2,3,2); imshow(im1, []); title('noL1\_WaTMRI');
 subplot(2,3,3); imshow(im2, []); title('noTV\_WaTMRI');
 subplot(2,3,5); imshow(im3, []); title('noboth\_WaTMRI');
 subplot(2,3,6) ;imshow(im4, []); title('WaTMRI');




