%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% This script is used to obtain the results in the paper
%%%% "MR Image Reconstruction with Wavelet Tree Sparsity"
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all; clear all;
rand('state',0); rand('state',0);

F = double(imread('pics/Heart.png'));
 F = double(imread('pics/3DMR_Chest.jpg'));
F = double(imread('pics/shoulder.jpg'));
F = double(imread('pics/MRI-Brain.jpg'));
F=imresize(F, [256 256]);[m n] = size(F); 


snr1=[];snr2=[];snr3=[];snr4=[];MAXTTER=5;
snrs1=zeros(MAXTTER,4);snrs2=zeros(MAXTTER,4);snrs3=zeros(MAXTTER,4);snrs4=zeros(MAXTTER,4);
for iter=1:MAXTTER
    fprintf('Iteration:%d----------------------------------------------------------------------\n',iter);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2D wavelet tree structure --  
DecLevel=4;
[IdxParent, IdxChildren, Ms] = WaveTreeStructure2D(m,DecLevel);
[G,Gmat,GmatX,groups]=GroupMatrics(IdxParent);
input.G=G;input.Gt=G';input.GtG=G'*G;
input.groups=groups;input.Gmat=Gmat;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Preparing the data and operators
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
N = m*n;f = F(:);
% define the function handles that compute 
% the products by W (inverse DWT) and W' (DWT)
wav = daubcqf(2);
WT = @(x) reshape(mdwt(reshape(x,m,n),wav,DecLevel),N,1);
W = @(x) reshape(midwt(reshape(x,m,n),wav,DecLevel),N,1);
W2 = @(x) midwt(x,wav,DecLevel);WT2 = @(x) mdwt(x,wav,DecLevel); %2D
Phi = A_operator(@(x) WT(x), @(x) W(x));    % notice Phi=WT
alpha = 0.001; 
beta = 3.5e-2; 
input.lamda=beta*0.2;
xs = WT(f);input.f=f; input.xs=xs;
input.n1=m;input.n2=n;
input.alpha=alpha;input.beta=beta;
input.Phi=Phi;
input.maxitr=500;input.maxiitr= 500;
input.stopCriterion=2; 
input.tolA=1e-8; input.no=50; %%%%  Change no for different iteration numbers
input.L=1;input.num=1; 
input.l=0; input.u=255;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for d =[4.0 4.3 5.0 5.4] 
% Number of projections
%R = 4.6;   % acceleration factor  % set 4.6--0.21
pdf = genPDF([1,m], 6, 1/d, 2, 0.1, 0);
OMEGA = fftshift(repmat(genSampling_symmetric(pdf,10,1),[m,1]));
% figure;imshow(OMEGA);
OMEGA = find(OMEGA==1);
% [OMEGA] = RandMask_rect(double(m/d),double(n/d),m,n);
k = length(OMEGA);
fprintf(1,'Ratio = %f \n',k/N);
[mask] = RandMask_InverseTransfer(OMEGA,m,n); 
sigma = 0.01; noise = sigma*randn(2*k+1,1); 
% partial FFT tranform
R = @(x) A_fhp_rect(x, OMEGA, m, n);
RT = @(x) At_fhp_rect(x, OMEGA, m, n);
RR = A_operator(@(x) R(x), @(x) RT(x));
b = R(f) + noise;input.b=b;input.A=RR;
AO = @(x) R(W(x)); AOT = @(x) WT(RT(x)); 
A = A_operator(@(x) AO(x), @(x) AOT(x));
input2=input;input2.A=A;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% TVCMRI  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('calling the function TVCMRI.....\n');
out = TVCMRI(input2);
out1=out; x = out.x; im1=Phi'*x; im1=reshape(im1, [m, n]);
fprintf(1,'Iter_time = %.2fsec, Iteration Num = %d, snr = %f \n',out.iter_time, input.no, out.snr(end));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% RecPF  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('calling the function RecPF.....\n');
opts.maxItr = input.no; opts.gamma = 1.6;opts.beta = 10;
opts.relchg_tol = 5e-4; opts.real_sol = true; 
opts.normalize = false; 
FB = fft2(F)/sqrt(m*n);
bb=FB(OMEGA)+sigma*randn(length(OMEGA), 1); 
pick=false(m,n);pick(OMEGA)=true;
[U,out] = RecPF(m,n,input.alpha,input.beta,pick,bb,2,opts,WT2,W2,range(F(:)),F);
out2=out; im2 = U; x=Phi*U(:);
fprintf(1,'Iter_time = %.2fsec, Iteration Num = %d, snr = %f \n',out.xtime(end), out.iter, out.snr(end));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% FCSA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('calling the function FCSA.....\n');
out = TVS_FCSAy(input);
out3=out;im3 = out.y; x=Phi*im3; im3=reshape(im3, [m, n]);
fprintf(1,'Iter_time = %.2fsec, Iteration Num = %d, snr = %f \n',out.xtime(end), input.no, out.snr(end));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% WaTMRI
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('calling the function WaTMRI.....\n');
out = WaTMRI(input);  % matlab wavelet
out4=out;im4 = out.y; x=Phi*im4; im4=reshape(im4, [m, n]);
fprintf(1,'Iter_time = %.2fsec, Iteration Num = %d, snr = %f \n',out.xtime(end), input.no, out.snr(end));

snr1=[snr1 out1.snr(end)];snr2=[snr2 out2.snr(end)];
snr3=[snr3 out3.snr(end)];snr4=[snr4 out4.snr(end)];
end
snrs1(iter,:) = snr1;snrs2(iter,:)=snr2;snrs3(iter,:) = snr3;snrs4(iter,:)=snr4;
snr1=[];snr2=[];snr3=[];snr4=[];
end
SNR_M1=mean(snrs1, 1);SNR_M2=mean(snrs2, 1);SNR_M3=mean(snrs3, 1);SNR_M4=mean(snrs4, 1);
SNR_S1=std(snrs1,0, 1);SNR_S2=std(snrs2,0, 1);SNR_S3=std(snrs3,0, 1);SNR_S4=std(snrs4,0, 1);
Sample = [0.25 0.23 0.20 0.18];
ls=3; ms=1; ts=12;

figure;imshow(mask,[]);

figure; hold on;box on;
errorbar(Sample,SNR_M1, SNR_S1, 'k-.', 'linewidth',ls, 'markersize', ms);
errorbar(Sample,SNR_M2, SNR_S2, 'g:', 'linewidth',ls, 'markersize', ms);
errorbar(Sample,SNR_M3, SNR_S3, 'r--', 'linewidth',ls, 'markersize', ms);
errorbar(Sample,SNR_M4, SNR_S4, 'b-', 'linewidth',ls, 'markersize', ms);

legend('TVCMRI','RecPF','FCSA','WaTMRI','Location','SouthEast');
xlabel('Sample Ratios');
ylabel('SNR');
