%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% This script is used to obtain the results in the paper
%%%% "MR Image Reconstruction with Wavelet Tree Sparsity"
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all; clear all;
randn('state',0);rand('state',0);

% F = phantom(512);
F = double(imread('pics/Heart.png'));
% F = double(imread('pics/3DMR_Chest.jpg'));
% F = double(imread('pics/shoulder.jpg'));
%  F = double(imread('pics/MRI-Brain.jpg'));
% load T2MRI;
% F = T2MRI(:,:,90,3);
% F = double(F);
% F = im256(F);
% load 3Tbrain;
% F = abs(F);
% F = im256(F);
F=imresize(F, [256 256]);[m n] = size(F); 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2D wavelet transformation and sparse signal --  
DecLevel=6;
[IdxParent, IdxChildren, Ms] = WaveTreeStructure2D(m,DecLevel);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Preparing the data and operators
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
N = m*n;f = F(:);
% define the function handles that compute 
% the products by W (inverse DWT) and W' (DWT)
wav = daubcqf(2);
WT = @(x) reshape(mdwt(reshape(x,m,n),wav,DecLevel),N,1);
W = @(x) reshape(midwt(reshape(x,m,n),wav,DecLevel),N,1);
W2 = @(x) midwt(x,wav,DecLevel);WT2 = @(x) mdwt(x,wav,DecLevel); %2D
Phi = A_operator(@(x) WT(x), @(x) W(x));    % notice Phi=WT
Phi2 = A_operator(@(x) WT2(x), @(x) W2(x));    % notice Phi=WT

alpha = 0.001; 
beta = 3.5e-2; 
input.lamda=beta*0.2;
xs = WT(f);input.f=f; input.xs=xs;
input.n1=m;input.n2=n;
input.alpha=alpha;input.beta=beta;
input.Phi=Phi;
input.maxitr=500;input.maxiitr= 500;
input.stopCriterion=2; 
input.tolA=1e-8; input.no=200; %%%%  Change no for different iteration numbers
input.L=1;input.num=1; 
input.l=-inf; input.u=inf;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

d = 4.4;   %%%% choose 3, 4, 
% Number of projections
[OMEGA] = RandMask_rect(double(m/d),double(n/d),m,n);
k = length(OMEGA);
[mask] = RandMask_InverseTransfer(OMEGA,m,n); 
% figure;imshow(mask);
sigma = 0.01; noise = sigma*randn(2*k+1,1);

% partial FFT tranform
R = @(x) A_fhp_rect(x, OMEGA, m, n);
RT = @(x) At_fhp_rect(x, OMEGA, m, n);
RR = A_operator(@(x) R(x), @(x) RT(x));
AO = @(x) R(W(x)); AOT = @(x) WT(RT(x)); 
A = A_operator(@(x) AO(x), @(x) AOT(x));
b = R(f) + noise;input.b=b;input.A=RR;
input2=input;input2.A=A;

data = zeros(m,n);data(1,1) = b(1); KK = length(b);
data(OMEGA) = b(2:(KK+1)/2) + i*b((KK+3)/2:KK);
im_poc = real(ifft2(data))*sqrt(m*n);

sampleratio = k/(m*n);
fprintf(1,'sample ratio = %.4f\n',sampleratio);

MAXTTER=1;
time0=zeros(MAXTTER,8);snrs0=zeros(MAXTTER,8);
time1=zeros(MAXTTER,input.no);time2=zeros(MAXTTER,input.no);
time3=zeros(MAXTTER,input.no);time4=zeros(MAXTTER,input.no);
snrs1=zeros(MAXTTER,input.no);snrs2=zeros(MAXTTER,input.no);
snrs3=zeros(MAXTTER,input.no);snrs4=zeros(MAXTTER,input.no);
for iter=1:MAXTTER
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Tree0
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mu = 3e-2;
opts = [];
opts.l=-inf;opts.up=inf;


opts.Verbose = 0;opts.TypeMin='l21';

delta = 1e-8;opts.MaxIntIter=1;

opts.maxiter=50;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Tree1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[G,Gmat,GmatX,groups]=GroupMatrics(IdxParent);
input.G=G;input.Gt=G';input.GtG=G'*G;
input.groups=groups;input.Gmat=Gmat;
input.beta = beta;
input.lamda=beta*0.2;
fprintf('calling the function Tree1.....\n');
muf = mu/2;
opts.U=@(x) G*(Phi*x);
opts.Ut =@(x) Phi'*(G'*x);
opts.groups=groups;opts.Gmat=Gmat;
opts.f=f;
[xk,niter,resid,outData] = NESTA(R,RT,b,muf,delta,opts);

SNR1 = outData.snr;
Time1 = outData.xtime;

% out1=out;im1 = out.y; im1=reshape(im1, [m, n]);
% fprintf(1,'Iter_time = %.2fsec, Iteration Num = %d, snr = %f \n',out.xtime(end), input.no, out.snr(end));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Tree2
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
coefrows = find(IdxParent~=0);
temp = zeros(size(IdxParent));
temp(coefrows) = IdxParent(IdxParent(coefrows));
IdxParent2 = [IdxParent temp];

[G,Gmat,GmatX,groups]=GroupMatrics(IdxParent2);
input.G=G;input.Gt=G';input.GtG=G'*G;
input.groups=groups;input.Gmat=Gmat;
muf = mu/3;
opts.U=@(x) G*(Phi*x);
opts.Ut =@(x) Phi'*(G'*x);
opts.groups=groups;opts.Gmat=Gmat;
opts.f=f;
[xk,niter,resid,outData] = NESTA(R,RT,b,muf,delta,opts);

SNR2 = outData.snr;
Time2 = outData.xtime;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Tree3
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
coefrows = find(IdxParent2(:,2)~=0);
temp = zeros(size(temp));
temp(coefrows) = IdxParent(IdxParent2(coefrows,2));
IdxParent3 = [IdxParent2 temp];
muf = mu/4;
[G,Gmat,GmatX,groups]=GroupMatrics(IdxParent3);
input.G=G;input.Gt=G';input.GtG=G'*G;
input.groups=groups;input.Gmat=Gmat;

opts.U=@(x) G*(Phi*x);
opts.Ut =@(x) Phi'*(G'*x);
opts.groups=groups;opts.Gmat=Gmat;
opts.f=f;
[xk,niter,resid,outData] = NESTA(R,RT,b,muf,delta,opts);

SNR3 = outData.snr;
Time3 = outData.xtime;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Tree4
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fprintf('calling the function Tree4.....\n');
% out = S_WaTMRI(input);
% out4=out;im4 = out.y; im4=reshape(im4, [m, n]);
% fprintf(1,'Iter_time = %.2fsec, Iteration Num = %d, snr = %f \n',out.xtime(end), input.no, out.snr(end));

% 
% % time0(iter,:)=out0.timeTrace;snrs0=out0.snrTrace;
% time1(iter,:)=out1.xtime;time2(iter,:)=out2.xtime;
% time3(iter,:)=out3.xtime;time4(iter,:)=out4.xtime;
% snrs1(iter,:)=out1.snr;snrs2(iter,:)=out2.snr;
% snrs3(iter,:)=out3.snr;snrs4(iter,:)=out4.snr;
end
% time0_M=mean(time0,1);snrs0_M=mean(snrs0,1);
% time1_M=mean(time1,1);time2_M=mean(time2,1);time3_M=mean(time3,1);time4_M=mean(time4,1);
% snrs1_M=mean(snrs1,1);snrs2_M=mean(snrs2,1);snrs3_M=mean(snrs3,1);snrs4_M=mean(snrs4,1);
 
lw=3;
figure; hold on;box on;
% plot(snrs0_M, 'm+-.','linewidth', lw);
plot(SNR1, 'k:','linewidth', lw);
plot(SNR2, 'g-.','linewidth', lw);
plot(SNR3, 'r--','linewidth', lw);
% plot(snrs4_M, 'b-','linewidth', lw);
legend('CG','TVCMRI','RecPF','FCSA','WaTMRI','Location','SouthEast');
xlabel('Iterations');
ylabel('SNR');
% 
textobj = findobj('type', 'text');
set(textobj, 'fontsize', 14);
h_xlabel = get(gca,'XLabel');
set(h_xlabel,'FontSize',14); 
h_xlabel = get(gca,'YLabel');
set(h_xlabel,'FontSize',14); 

 figure; hold on;box on;
%  plot(time0_M, snrs0_M, 'm+-.','linewidth', lw);
 plot(Time1, SNR1, 'k:','linewidth', lw);
 plot(Time2, SNR2, 'g-.','linewidth', lw);
 plot(Time3, SNR3, 'r--','linewidth', lw);
%  plot(time4_M, snrs4_M, 'b-','linewidth', lw); 
% axis([0 2 3.5 20]);
legend('CG','TVCMRI','RecPF','FCSA','WaTMRI','Location','SouthEast');
 xlabel('CPU Time(sec)');
 ylabel('SNR');

 textobj = findobj('type', 'text');
set(textobj, 'fontsize', 14);
h_xlabel = get(gca,'XLabel');
set(h_xlabel,'FontSize',14); 
h_xlabel = get(gca,'YLabel');
set(h_xlabel,'FontSize',14); 


%  figure; hold on;
%  subplot(2,3,1); imshow(F, []); title('Original');
% %  subplot(2,3,2); imshow(im0, []); title('CG');
%  subplot(2,3,3); imshow(im1, []); title('TVCMRI');
%  subplot(2,3,4); imshow(im2, []); title('RecPF');
%  subplot(2,3,5); imshow(im3, []); title('FCSA');
%  subplot(2,3,6) ;imshow(im4, []); title('WaTMRI');




